.device	ATmega8
.nolist
.include "m8def.inc"
.list
;********************************** Definitions
.def	temp = r16
;********************************* end Definitions
.org	0
		rjmp	start
.org	OVF0addr
		rjmp	tmr0_int
.org	INT_VECTORS_SIZE
;----
start:
;---- set stack pointer
		ldi		temp,low(ramend)	;init stack pointer
		out		spl,temp			;
		ldi		temp,high(ramend)	;
		out		sph,temp			;
;----
		ldi		temp,(1<<ACD)		;disable Analog Comparator
		out		ACSR,temp			;
		sei							;enable interrupts 
;======== main loop ================
; T0
init_timer:
		clr		temp
		out		TIFR,temp			;reset interrupts of timers
		out		TCNT0,temp			;clear internal T/C counter
		ldi		temp,(1<<TOIE0)
		out		TIMSK,temp			;T/C0 Overflow Interrupt Enable
		ldi		temp,(1<<PSR10)
		out		SFIOR,temp			;reset Prescaler T/C 1&0
		ldi		temp,(1<<CS02|0<<CS01|1<<CS00)
;START breakpoint
		out		TCCR0,temp			;set perscaler = 1024 and start timer0
		ldi		temp,$ff			;set external counter
;======== wait overflow ============
wait:
		tst		temp
		brne	wait
;======== stop timer ===============
;STOP breakpoint
		out		TCCR0,temp			;stop T/C0
		out		TIMSK,temp			;disable all T/C Overflow Interrupts
;======= repeat main loop ==========
		rjmp	init_timer
;*** interrupt on T/C0 overflow ****
tmr0_int:
		inc		temp
		reti
;*** END ***